# **********************************************************************
# Copyright 2017 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import nsx_logging
import json

from cli.commands.cli_command_provider import CliCommandProvider
from cli.commands.lcp_common.hyperbus.client import get_hyperbus_cli_output

lg = nsx_logging.getLogger("cli.commands.lcp_common.hyperbus.hyperbus")

class GetHyperBusLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_hyperbus_cli_output("get/loglevel")
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class SetHyperBusLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[4]
        response = get_hyperbus_cli_output("set/loglevel", [log_level])
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class GetHyperBusMetricsLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_hyperbus_cli_output("get-metrics/loglevel")
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class SetHyperBusMetricsLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_hyperbus_cli_output("set-metrics/loglevel", [log_level])
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class GetHyperBusNetLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_hyperbus_cli_output("get-net/loglevel")
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class SetHyperBusNetLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_hyperbus_cli_output("set-net/loglevel", [log_level])
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class GetHyperBusRpcLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_hyperbus_cli_output("get-rpc/loglevel")
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class SetHyperBusRpcLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_hyperbus_cli_output("set-rpc/loglevel", [log_level])
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class GetHyperBusNestDbLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_hyperbus_cli_output("get-nestdb/loglevel")
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)

class SetHyperBusNestDbLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_hyperbus_cli_output("set-nestdb/loglevel", [log_level])
        if response is None:
            return "MSG_HYPERBUS_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)
