# **********************************************************************
# Copyright 2019 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
import json

from cli.commands.cli_command_provider import CliCommandProvider
from cli.commands.lcp_common.opsagent.client import get_opsagent_cli_output
from cli.commands.lcp_common.opsagent.client import load_response_output


class GetIdsEvtStats(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_opsagent_cli_output("get/idsStats")
        if response is None:
            return "MSG_IDSEVT_STATS_FAILED"

        jobj = json.loads(response)
        return "OK\n\n%s" % json.dumps(jobj)


class ClearIdsEvtStats(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_opsagent_cli_output("clear/idsStats")
        if response is None:
            return "MSG_IDSEVT_STATS_FAILED"

        return "OK\n\n%s" % json.dumps(response)

