# ***************************************************************************
# Copyright 2014-2017 VMware, Inc.  All rights reserved. VMware Confidential.
# ***************************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# ***************************************************************************
import socket


_SESSION_PROMPT = "SESSION-MODE"


class CliPrompt(object):
    """Class specifying how user prompt is displayed given different modes."""
    def __init__(self):
        self._postfix = ">"

    def get_prompt(self, session_mode_active=False):
        return "%s%s " % (
            _SESSION_PROMPT if session_mode_active else socket.gethostname(),
            self._postfix)
        # TODO: replace above line with following lines after VDnet tests
        # are updated to expect the username in the prompt.
        #import getpass
        #return "%s@%s%s " % (
        #    getpass.getuser(),
        #    _SESSION_PROMPT if session_mode_active else socket.gethostname(),
        #    self._postfix)

    def enable_prompt(self):
        self._postfix = ">"

    def configure_prompt(self):
        self._postfix = "(config)#"

    def interface_prompt(self):
        self._postfix = "(config-if)#"

    def vrf_prompt(self):
        self._postfix = "(vrf)>"

    def tier0_sr_prompt(self):
        self._postfix = "(tier0_sr)>"

    def tier1_sr_prompt(self):
        self._postfix = "(tier1_sr)>"

    def tier0_vrf_sr_prompt(self):
        self._postfix = "(tier0_vrf_sr)>"

    def remote_tunnel_vrf_prompt(self):
        self._postfix = "(remote_tunnel_vrf)>"

    def path_prompt(self):
        self._postfix = "(path)>"

    def offlinepath_prompt(self):
        self._postfix = "(offlinepath)>"

    def inter_sr_vrf_prompt(self):
        self._postfix = "(inter_sr_vrf)>"
