import struct
import sys
try:
    import simplejson
except ImportError:
    import json as simplejson


if sys.version_info < (3,):
    import cPickle as pickle
    from ConfigParser import ConfigParser
    from StringIO import StringIO
    from types import LongType
    from types import StringTypes
    from urllib import urlencode
    from urlparse import urlparse
    from itertools import izip_longest
    compat23_basestring = basestring
    compat23_JSONDecodeError = (
        simplejson.JSONDecodeError if "JSONDecodeError" in dir(simplejson)
        else ValueError)
    compat23_long = long
    compat23_long_type = LongType
    compat23_pickle = pickle
    compat23_raw_input = raw_input
    compat23_string_types = StringTypes  # tuple value
    compat23_unichr = unichr
    compat23_unicode = unicode
    compat23_zip_longest = izip_longest
    if sys.platform == "win32":
        import _winreg as winreg
else:
    from configparser import ConfigParser
    from io import StringIO
    import pickle
    from urllib.parse import urlencode
    from urllib.parse import urlparse
    from itertools import zip_longest
    compat23_basestring = str
    compat23_JSONDecodeError = ValueError
    compat23_long = int
    compat23_pickle = pickle
    compat23_raw_input = input
    compat23_string_types = str
    compat23_unichr = chr
    compat23_unicode = str
    compat23_zip_longest = zip_longest
    if sys.platform == "win32":
        import winreg

compat23_ConfigParser = ConfigParser

compat23_StringIO = StringIO

compat23_urlencode = urlencode
compat23_urlparse = urlparse

if sys.platform == "win32":
    compat23_winreg = winreg


def compat23_pack_network_value(value):
    fmt = "I" if sys.version_info >= (3,) else "L"
    return struct.pack(fmt, value)


def force_unicode(s, encoding='utf-8', errors='ignore'):
    """
    Returns a unicode object representing 's'. Treats bytestrings using the
    'encoding' codec.
    """
    if s is None:
        return ''

    try:
        if not isinstance(s, compat23_basestring):
            if hasattr(s, '__unicode__'):
                s = compat23_unicode(s)
            else:
                return s
        elif not isinstance(s, compat23_unicode):
            # Note: We use .decode() here, instead of unicode(s, encoding,
            # errors)
            s = s.decode(encoding, errors)
    except UnicodeDecodeError as e:
        if not isinstance(s, Exception):
            raise UnicodeDecodeError(s, *e.args)
        else:
            # If we get to here, the caller has passed in an Exception
            # subclass populated with non-ASCII bytestring data without a
            # working unicode method. Try to handle this without raising a
            # further exception by individually forcing the exception args
            # to unicode.
            s = ' '.join([force_unicode(arg, encoding, errors) for arg in s])
    return s


def dictitems(dict_arg):
    """Returns a Python 2 & 3 compatible iterator over dictionaries"""
    if sys.version_info < (3,):
        return dict_arg.iteritems()
    else:
        return dict_arg.items()
