# Copyright (C) 2019 VMware, Inc. All rights reserved.
# -- VMware Confidential

import abc


class BaseProvider(metaclass=abc.ABCMeta):

    @abc.abstractmethod
    def sync(self, msg):
        """To sync data to the provider"""
        raise NotImplemented

    @abc.abstractmethod
    def close(self):
        """To close the provider"""
        raise NotImplemented

    @property
    def name(self):
        raise NotImplemented

