# Copyright (C) 2020 - 2021 VMware, Inc. All rights reserved.
# -- VMware Confidential

logger.info("data_store:{}".format(data_store))

def handle_notification(service, notification, profile):
    FEATURE_NAME = "infrastructure_service"
    EVENT_TYPE = feature_event_type_mappings.INFRASTRUCTURE_SERVICE_SERVICE_STATUS_UNKNOWN_EVENT_TYPE_ID
    old_state = notification['old_state']
    new_state = notification['new_state']
    ENTITY_ID = notification['eid']
    logger.info("service {} id {} old state {} new state {}".format(service, ENTITY_ID, old_state, new_state))
    context = {"service_name" : service}
    """
    From monitor, only three possible changes: None->UP, UP->DOWN, DOWN->UP
    could be sent to plugin, so we only handle these three changes.
    None->UP, try to clear any legacy alarm, which was left before removal of the client
    DOWN->UP, clear the alarm
    UP->DOWN, set the alarm
    """
    if new_state == "UP":
        Alarm(status = {EVENT_TYPE : {ENTITY_ID: (False, context)}}, feature = FEATURE_NAME)
    elif (old_state == "UP") and (new_state == "DOWN"):
        Alarm(status = {EVENT_TYPE : {ENTITY_ID: (True, context)}}, feature = FEATURE_NAME)
    else:
        logger.info("No need to report for service {} from {} to {}".format(service, old_state, new_state))


profile = data_store['profile']
for key in data_store['metrics'].keys():
    if data_store['metrics'][key]:
        notification = data_store['metrics'][key]['value']
        service = key.split('.')[2].strip()
        handle_notification(service, notification, profile)
    else:
        logger.warn("Metric {}: No changes needs be reported.".format(key))
